/* Ver_2
   Originally based on tray_egect and pcmanfm and ALT path to xfce4-places-plugin-1.2.0

   Licensed under the GNU GPL

   YYY from forum.altlinux.org

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <unistd.h>
#include <sys/stat.h> //detect file manager

#include <gio/gio.h>
#include "libudev.h"

#include "tray.h"

#define ICON_PATH ICON_DIR "/tray_eject_plus/"
#define MEDIA_DIR "/media/"
//#define FILE_BROWSER "nautilus" //see fileman
#define MOUNT "/bin/mount"
#define UMOUNT "/bin/umount"  

GHashTable *dev; //GHashTable    - all device
GtkWidget *menu, *item, *sep; //menu and widget for menu
GtkWidget *dialog, *msg, *dialog2, *msg2; //dialog widget
GtkStatusIcon *icon;  //programms icon for tray

int count; //count of mount devices
int countotal; //count of all devices if= -999 programms not ready yet (after start)

char fileman[256]; //name of file manager

GList* fstabdrive=NULL;   //list not visible device from fstab
GList* allfstabdrive=NULL;  //list all device from fstab
GList* allfstabmountpoint=NULL;   //list all mount point from fstab

int usefloppy=-999;  // use floppy flag. if  usefloppy>-1 it mean floppy exists. if usefloppy=0 then floppy device=/dev/fd0 if usefloppy=1 then floppy device=/dev/fd1 and etc...
char floppymp[256]; //floppy mount point

GtkWidget *fdsubm, *fdsub, *fdimg, *fditem, *fditem_i, *fditem_content, *fditem_c_i, *fditem_mount, *fditem_m_i; //floppy drive widget

char *mountlab; //mount label contains label of device

int changeiconflag=0; //need for icons blink

static GVolumeMonitor* vol_mon = NULL; //A Volume Monitor that watches for volume events. is for listing the user interesting devices and volumes on the computer. In other words, what a file selector or file manager would show in a sidebar.

int res=0;


struct mdev {
	GVolume *vol;    
	GtkWidget *item;
	GtkWidget *item_mount;
	GtkWidget *item_content;
	char *mountpoint;
	//info
	char *label;
	char *ctype;
	char *blockdev;
	char *udi;
	char *fstype;
	char *name;	
	int size;
	int mount;
	int type;
	int eject;	
	//summenu widget
	GtkWidget *submenu;
	GtkWidget *submenuitem;
	GtkWidget *img;
	GtkWidget *item_i;
	GtkWidget *item_m_i;
	GtkWidget *item_c_i;
}; //struct mdev end



//+++++++ update_count count variable  (update_status->update_count)
void update_count(gpointer key, gpointer value, gpointer user_data)
{
    	struct mdev *m = value;
    	if (m->mount==1) count++;
}
//+++++++ update_count


// ++++++++++++++ update_status  (first main->update_status and...)
void update_status()
{

	//count all dev
	countotal=(int) g_hash_table_size(dev);
	
	count=0;
	if (countotal>0){ 
	    g_hash_table_foreach(dev, (GHFunc)update_count, "ok");
	}


	if (changeiconflag==0){
	    if (count) {
		//gtk_widget_show(sep);
		//gtk_widget_set_sensitive(item, TRUE);
		gtk_status_icon_set_from_file(icon, ICON_PATH "dev1.png");
	    } else {
		//gtk_widget_hide(sep);
		//gtk_widget_set_sensitive(item, FALSE);
		gtk_status_icon_set_from_file(icon, ICON_PATH "dev0.png");
	    }
	    //gtk_status_icon_set_blinking (icon, FALSE);
	}


	char txt[100];
	
	snprintf(txt, 100, "Mount devices:	%i\nUnMount devices:	%i", count, countotal-count);
	gtk_status_icon_set_tooltip(icon, txt);

	if (usefloppy>-1) countotal++;
	gtk_status_icon_set_visible(icon, !!countotal);
	//gtk_status_icon_set_visible(icon, !!count);
}
// ++++++++++++++ update_status


//++++++++++++++++ popup (main->popup)
static void popup(GtkWidget *gw, GdkEventButton *event, gpointer userdata)
{
g_print("counttotal|%i|\n", countotal);
	if (event->type==GDK_BUTTON_PRESS){
	    if (event->button==2){
		//close program ?

		GtkWidget *exitdialog = gtk_dialog_new_with_buttons("Quit ?", 
		NULL, 
		GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT, 
		GTK_STOCK_YES, GTK_RESPONSE_YES,
		GTK_STOCK_NO, GTK_RESPONSE_NO,
		NULL);
		
		gtk_window_set_icon_from_file(GTK_WINDOW(exitdialog), ICON_PATH "dev0.png", NULL);

		GtkWidget *exitmsg = gtk_label_new(_("Quit a program ?"));
		gtk_box_pack_start(GTK_BOX(GTK_DIALOG(exitdialog)->vbox), exitmsg, TRUE, TRUE, 10);
    		gtk_widget_show(exitmsg);

    		gtk_widget_show(exitdialog);
		if (  gtk_dialog_run(GTK_DIALOG(exitdialog))==GTK_RESPONSE_YES  ){
		    gtk_main_quit();
		}
        	gtk_widget_hide(exitdialog);
	    
	    }
	    if (event->button==1 || event->button==3){
		//show menu
		if (countotal>0){ 
		    gtk_menu_popup(GTK_MENU(menu), NULL, NULL, NULL, NULL, 3, gtk_get_current_event_time());
		}
	    }
	}
}
//++++++++++++++++ popup




//+++++++++++++++++ mftrue (access__floppy -> mftrue )
static int mftrue(void){
	//return 0 if floppy mount now...
	int okok=1;

	FILE *myfile;
	char string[300];
	char string2[300];
	char *temp;

	if ( ( myfile=fopen("/etc/mtab", "r") )!=(FILE *)0  ){
	    while ( ( fgets(string, 299, myfile) )!=(char *)0  ){
		snprintf(string2, 299, "%s", string);
		temp=strtok(string, " ");
		while (temp!=NULL){
			if ( strcmp(temp, floppymp) == 0 ){
				okok=0;
g_print("mftrue: i find %s in %s\n", floppymp, string2);
			}
			temp=strtok(NULL, " ");
			if (okok==0) break;
		}
		if (okok==0) break;
	    }//while
	    fclose(myfile);
	}

	return okok;
}   
//+++++++++++++++++ mftrue

//+++++++++++++++++ eject__floppy (  floppymenu ->eject__floppy)
static void eject__floppy(void)
{

		res=1;
	if (mftrue()==0){
		
                  GError *err = NULL;
                  char *sout = NULL;
                  char *serr = NULL;
                  char *args[3] = {UMOUNT, NULL, NULL};
                  char **envp = {NULL};
		    
                  args[1] = floppymp;
                  args[2] = NULL;
g_print("infstab\nUNMOUNT G_SPAWN_SYNC MP=|%s|\n", floppymp);
                  if ( !g_spawn_sync ("/", args, envp, 0, NULL, NULL, &sout, &serr, &res, &err) ){
			g_print("\n%s ERROR!\n", UMOUNT);
                  }
		  if (res!=0){
		    g_print("ERROR: %s  OUT:%s\n", serr, sout);
		  }
		
		
		if (res) {
        	gtk_widget_show(dialog);
		gtk_dialog_run(GTK_DIALOG(dialog));
        	gtk_widget_hide(dialog);
		}
	}else{
g_print("floppy not mount now");
	}
}
//+++++++++++++++++ eject__floppy 

//+++++++++++++++++ mount_floppy ( floppymenu -> mount_floppy)
static void mount_floppy(void)
{

		res=1;
	if (mftrue()!=0){
    
                  GError *err = NULL;
                  char *sout = NULL;
                  char *serr = NULL;
                  char *args[3] = {NULL, NULL, NULL};
                  char **envp = {NULL};

                  args[0] = MOUNT;
                  args[1] =floppymp;
	              args[2]=NULL;
g_print("infstab\nMOUNT G_SPAWN_SYNC MP=|%s|\n", floppymp);
                      if ( !g_spawn_sync ("/", args, envp, 0, NULL, NULL, &sout, &serr, &res, &err) ){
			g_print("\n%s ERROR!\n", MOUNT);
                      }
		    if (res!=0){
			g_print("ERROR: %s  OUT:%s\n", serr, sout);
		    }
	
		if (res) {
        	gtk_widget_show(dialog2);
		gtk_dialog_run(GTK_DIALOG(dialog2));
        	gtk_widget_hide(dialog2);
		}
	}else{
g_print("floppy mount now");
	}

}
//+++++++++++++++++ mount_floppy


//+++++++++++++++++ access__floppy  (floppymenu -> access__floppy)
static void access__floppy(void)
{

	int pid=0;
	char cmd[256];

	if (mftrue()==0){
		pid=1;
	} else {
		mount_floppy();
		sleep(1);
		if (mftrue()==0){
			pid=1;
		}
	}

	if ( pid==1 ){	
	       pid = fork();
	       if (!pid) {
		   snprintf(cmd, 256, "%s%s", fileman, floppymp);
g_print("go_fl|%s|\n", cmd);
		   res |= system(cmd);
		   exit(1);
       		}
	}else{
	    g_print("can't open - floppy not mount");
	}

} 
//+++++++++++++++++ access__floppy


//++++++++++++++++ floppymenu  (init_udev->floppymenu)
static void floppymenu(void)
{

	char myimg[1024];

	char txt[80];
	snprintf(txt, 80, "%s %s%i", _("Floppy Drive"), "/dev/fd", usefloppy);

	fdsubm= gtk_menu_new();
	fdsub=gtk_image_menu_item_new_with_label(txt);
	snprintf(myimg, 1024, "%sfloppydrive_mount.png", ICON_PATH);
	fdimg = gtk_image_new_from_file(myimg);
	gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(fdsub), fdimg);
	gtk_widget_show(fdsub);
	gtk_menu_item_set_submenu(GTK_MENU_ITEM(fdsub), fdsubm);
	gtk_menu_shell_append(GTK_MENU_SHELL(menu), fdsub);



	//MOUNT

	snprintf(txt, 80, "%s", _("Mount"));

	fditem_mount = gtk_image_menu_item_new_with_label(txt);
	fditem_m_i = gtk_image_new_from_file(ICON_PATH "mount.png");
	gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(fditem_mount), fditem_m_i);
        gtk_widget_show(fditem_mount);
        gtk_menu_shell_append(GTK_MENU_SHELL(fdsubm), fditem_mount);
	g_signal_connect(G_OBJECT(fditem_mount), "activate", G_CALLBACK(mount_floppy), NULL);


	//VIEW

        snprintf(txt, 80, "%s %s%i", _("Access content on"), "/dev/fd", usefloppy );

        fditem_content =gtk_image_menu_item_new_with_label(txt);
	fditem_c_i = gtk_image_new_from_file(ICON_PATH "look.png");
	gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(fditem_content), fditem_c_i);
        gtk_widget_show(fditem_content);
        gtk_menu_shell_append(GTK_MENU_SHELL(fdsubm), fditem_content);
        g_signal_connect(G_OBJECT(fditem_content), "activate", G_CALLBACK(access__floppy), NULL);

	//UMOUNT

	snprintf(txt, 80, "%s %s%i", _("Safely remove"), "/dev/fd", usefloppy );


	fditem = gtk_image_menu_item_new_with_label(txt);
	fditem_i = gtk_image_new_from_file(ICON_PATH "unmount.png");
	gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(fditem), fditem_i);
        gtk_widget_show(fditem);
        gtk_menu_shell_append(GTK_MENU_SHELL(fdsubm), fditem);
	g_signal_connect(G_OBJECT(fditem), "activate", G_CALLBACK(eject__floppy), NULL);
}             
//++++++++++++++++ floppymenu


//++++++++++++++++ eject_finish (eject_device->eject_finish)
static void eject_finish(GObject *object, GAsyncResult *result, gpointer user_data)
{
	g_print("eject_finish begin\n");	
    GVolume *volume = G_VOLUME(object);
    GError *error = NULL;

    g_return_if_fail(G_IS_VOLUME(object));
    g_return_if_fail(G_IS_ASYNC_RESULT(result));

    if (!g_volume_eject_with_operation_finish(volume, result, &error)) {
         if(error->domain != G_IO_ERROR || error->code != G_IO_ERROR_FAILED_HANDLED) {
            gchar *volume_name = g_volume_get_name(volume);
            g_print("Failed to eject \"%s\"", volume_name);
            g_free(volume_name);
			
			gtk_widget_show(dialog);
			gtk_dialog_run(GTK_DIALOG(dialog));
			gtk_widget_hide(dialog);             
			
         }
         g_error_free(error);
    }{
            g_print("eject OK\n");		
	}    
}
//++++++++++++++++ eject_finish

//++++++++++++++++ eject_finish_mount (eject_device->eject_finish_mount)
static void eject_finish_mount(GObject *object, GAsyncResult *result, gpointer user_data)
{
	g_print("eject_finish_mount begin\n");
    GMount * mount = G_MOUNT(object);
    GError *error = NULL;

    g_return_if_fail(G_IS_MOUNT(object));
    g_return_if_fail(G_IS_ASYNC_RESULT(result));

    if (!g_mount_unmount_with_operation_finish(mount, result, &error)) {
         if(error->domain != G_IO_ERROR || error->code != G_IO_ERROR_FAILED_HANDLED) {
            gchar *mount_name = g_mount_get_name(mount);
            g_print("Failed to unmount \"%s\"", mount_name);
            g_free(mount_name);
			
			gtk_widget_show(dialog);
			gtk_dialog_run(GTK_DIALOG(dialog));
			gtk_widget_hide(dialog);             
			
         }
         g_error_free(error);
    }else{
            g_print("unmount OK\n");		
	}  
}
//++++++++++++++++ eject_finish_mount 

// +++++++++++++ eject_device (add_volume->eject_device)
static void eject_device(gpointer key, gpointer value, gpointer user_data)
{
	g_print("eject_device  begin\n");
	struct mdev *m = value;
	//m->mount
	//m->eject=1
	res=0;	
	if (m->mount==1 ){
			if (m->eject==1){
				GVolume *volume;
				volume = G_VOLUME(m->vol); 
				g_volume_eject_with_operation(volume, G_MOUNT_UNMOUNT_NONE, NULL, NULL, eject_finish, g_object_ref(volume));
			}else{
				GMount * mount;
				GVolume *volume;
				volume = G_VOLUME(m->vol);  				
				mount = g_volume_get_mount(volume);
				if (mount){
					g_mount_unmount_with_operation (mount, G_MOUNT_UNMOUNT_NONE, NULL, NULL, eject_finish_mount, g_object_ref(mount));
				}else{
								res=1;
				}	
				g_object_ref(volume);
			}
	}else{
			res=1;
	}    
	
	if (res) {
			gtk_widget_show(dialog);
			gtk_dialog_run(GTK_DIALOG(dialog));
			gtk_widget_hide(dialog); 
	}
	g_print("eject_device  end\n");	
}
// +++++++++++++ eject_device



//++++++++++++++++ mount_finish (mount_device->mount_finish)
static void mount_finish(GObject *object, GAsyncResult *result, gpointer user_data)
{
	g_print("mount_finish begin\n");	
    GVolume *volume = G_VOLUME(object);
    GError *error = NULL;

    if (!g_volume_mount_finish(volume, result, &error)) {
         if(error->domain != G_IO_ERROR || error->code != G_IO_ERROR_FAILED_HANDLED) {
            gchar *volume_name = g_volume_get_name(volume);
            g_print("Failed to mount \"%s\"", volume_name);
            g_free(volume_name);
			
			gtk_widget_show(dialog2);
			gtk_dialog_run(GTK_DIALOG(dialog2));
			gtk_widget_hide(dialog2);            
			
         }
         g_error_free(error);
    }{
            g_print("Mount OK\n");		
	}    
}
//++++++++++++++++ mount_finish

//+++++++++++++ mount_device (add_volume->mount_device)
static void mount_device(GtkWidget *widget, gpointer value)
{
	struct mdev *m = value;

	//m->blockdev
	//m->mount
	res=0;
	
	if (m->mount==0 && strcmp(m->blockdev, "") != 0 ){
			//m->vol;
			//g_volume_mount ((GVolume *) m->vol, 0, NULL, NULL, NULL, 0);
			//res=0;
				GVolume *volume;
				volume = G_VOLUME(m->vol); 
				GMountOperation *operation = gtk_mount_operation_new(NULL);
				g_volume_mount(volume, G_MOUNT_MOUNT_NONE, operation, NULL, mount_finish, g_object_ref(volume));			
	}else{
		res=1;		
	}


	if (res) {
        gtk_widget_show(dialog2);
		gtk_dialog_run(GTK_DIALOG(dialog2));
        gtk_widget_hide(dialog2);
	}

} 
//+++++++++++++ mount_device


//+++++++++++access_device   (add_volume->access_device)
//static void access_device(gpointer key, gpointer value, gpointer user_data)
static void access_device(GtkWidget *widget, gpointer value)
{
	int pid=1;
	struct mdev *m = value;
	char cmd[256];
	
	if (value && strcmp(m->mountpoint, "") != 0 ) {
	       pid = fork();
	       if (!pid) {
		   snprintf(cmd, 256, "%s\"%s\"", fileman, m->mountpoint);
g_print("go|%s|\n", cmd);
		   res |= system(cmd);
		   exit(1);
	       }
	}
}
//+++++++++++access_device


//++++++++++++++++ add_volume
static gboolean add_volume(GVolume* vol)
{

    if(!g_volume_can_mount(vol)) {
        g_print("add_volume: cant mount volume %p \n", vol);
	return FALSE; //can't mount vol
    }

    struct mdev *m; 
	if ((m = malloc(sizeof(*m))) == NULL) {
		perror("malloc");
		return FALSE;
	}     


    //all ok... continued
    g_print("+++++++++++++++++++++++++++++++++++++++++++++++++\n");    
    g_print("add_volume: try get volume %p parametrs.... \n", vol);    

	char * v_name=NULL;
	v_name=g_volume_get_name(vol); 
    g_print("name=%s\n", v_name);    
	char * v_uuid=NULL;
	v_uuid=g_volume_get_uuid(vol); 	
    g_print("uuid=%s\n", v_uuid);    
    	
	char * v_haludi=NULL;
	v_haludi=g_volume_get_identifier(vol, G_VOLUME_IDENTIFIER_KIND_HAL_UDI); 	
    g_print("HAL_UDI=%s\n", v_haludi);    
	char * v_label=NULL;
	v_label=g_volume_get_identifier(vol, G_VOLUME_IDENTIFIER_KIND_LABEL); 	
    g_print("KIND_LABEL=%s\n", v_label);    
	char * v_dev=NULL;
	v_dev=g_volume_get_identifier(vol, G_VOLUME_IDENTIFIER_KIND_UNIX_DEVICE); 		
    g_print("KIND_UNIX_DEVICE=%s\n", v_dev);    
	char * v_nfs=NULL;
	v_nfs=g_volume_get_identifier(vol, G_VOLUME_IDENTIFIER_KIND_NFS_MOUNT); 			
    g_print("KIND_NFS_MOUNT=%s\n", v_nfs);    
	char * v_kinduuid=NULL;
	v_kinduuid=g_volume_get_identifier(vol, G_VOLUME_IDENTIFIER_KIND_UUID); 				
    g_print("KIND_UUID=%s\n", v_kinduuid);    
    
    gboolean v_can_eject=g_volume_can_eject(vol);
    g_print("can_eject = %i\n", v_can_eject);
  
    //char **vei=g_volume_enumerate_identifiers(vol);
	//int vnum=g_strv_length(vei);
	//int viii;
	//for (viii=0; viii<vnum; viii++) {
	//g_print("vei=%s\n", vei[viii]);	
	//}  
  
    
    GFile  *file;
    GMount* mount;


    gboolean v_mount=FALSE;

    char * f_uri=NULL;
    char * f_path=NULL;    
	char * m_name=NULL;
	char * m_uuid=NULL;	
	
    
    mount = g_volume_get_mount(vol);
    if(mount) {//if  mount is NULL   - dev not mount
		v_mount=TRUE;
		file = g_mount_get_root(mount);
		
		f_uri = g_file_get_uri (file);
        g_print("uri=%s\n", f_uri);	
		f_path = g_file_get_path (file);
        g_print("path=%s\n", f_path);		

        m_name=g_mount_get_name(mount);
        g_print("name=%s\n", m_name);	
        m_uuid=g_mount_get_uuid(mount);	
        g_print("uuid=%s\n", m_uuid);	

	    g_object_unref (file);
    }else{
        g_print("add_volume: mount = false\n");
    }



	GDrive * drive;
	gboolean v_drive=FALSE;
	
	char * d_name=NULL;
	
	drive = g_volume_get_drive (vol);
    if(drive) {
		v_drive=TRUE;
		d_name = g_drive_get_name (drive);
        g_print("d_name=%s\n", d_name);	
        
        //char **ei=g_drive_enumerate_identifiers(drive);
		//int num=g_strv_length(ei);
		//int iii;
		//for (iii=0; iii<num; iii++) {
		//	g_print("ei=%s\n", ei[iii]);	
		//}

    }
    
    //get type, size and filesustem

    gboolean v_devinfo=FALSE;    
    char * v_str_type=NULL;
    int v_type=0;
    char * v_str_fs=NULL;    
    char * v_str_bus=NULL;        
    char * v_str_size=NULL;  
    int v_size=0;      
    int v_usbstorage=0;
    char temp[1024];
    
    
    
    
    if (v_dev!=NULL){
	
		struct stat statbuf;
		
		struct udev *udev;
		
		struct udev_device *device = NULL;	
		char type;

		udev = udev_new();
		if (udev == NULL){
			g_print("cant initialize udev!\n");					
		}else{

			if (stat(v_dev, &statbuf) < 0) {
				g_print("v_dev wrong ! cant find type, size and filesustem\n");		
			}else{
			  type = 'e';
              if (S_ISBLK(statbuf.st_mode)) {
                             type = 'b';
              } else if (S_ISCHR(statbuf.st_mode)) {
                             type = 'c';
              } else {
				g_print("device node has wrong file type! cant find type, size and filesustem\n");
				type = 'e';
              }			
              if (type != 'e'){
				  //all ok... continued
                  device = udev_device_new_from_devnum(udev, type, statbuf.st_rdev);
                  if (device == NULL) {
						g_print("device node not found! cant find type, size and filesustem\n");
                  }else{
					 //go go   :)
g_print("devinfo-ok\n");	
					v_devinfo=TRUE;				 
					struct udev_list_entry *list_entry;
					udev_list_entry_foreach(list_entry, udev_device_get_properties_list_entry(device)){
						
						//printf("E: %s=%s\n", udev_list_entry_get_name(list_entry), udev_list_entry_get_value(list_entry));						
						if ( strcmp(udev_list_entry_get_name(list_entry), "ID_TYPE") == 0 )	 {
							snprintf(temp, 1024, "%s", udev_list_entry_get_value(list_entry));
							v_str_type=strdup(temp);
						}	

						if ( strcmp(udev_list_entry_get_name(list_entry), "ID_BUS") == 0 )	 {
							snprintf(temp, 1024, "%s", udev_list_entry_get_value(list_entry));
							v_str_bus=strdup(temp);
						}	

						if ( strcmp(udev_list_entry_get_name(list_entry), "ID_FS_TYPE") == 0 )	 {
							snprintf(temp, 1024, "%s", udev_list_entry_get_value(list_entry));
							v_str_fs=strdup(temp);
						}	

						if ( strcmp(udev_list_entry_get_name(list_entry), "UDISKS_PARTITION_SIZE") == 0 )	 {
							snprintf(temp, 1024, "%s", udev_list_entry_get_value(list_entry));
							v_str_size=strdup(temp);						
							if (v_str_size!=NULL) v_size=(int) (  atoll((const char *)v_str_size)/(1024*1024)  );
						}	

						if ( strcmp(udev_list_entry_get_name(list_entry), "ID_USB_DRIVER") == 0 &&  strcmp(udev_list_entry_get_value(list_entry), "usb-storage") == 0)	{
							 v_usbstorage=1;
						}	 
						 
					}
					//type of dev
					if ( strcmp(v_str_type, "disk") == 0 ){
						v_type=3; //disk
						if (v_usbstorage==1){
							v_type=5; //usb flash
							if (v_size>18000) v_type=6; //usb disk 
						}
					}else if ( strcmp(v_str_type, "cd") == 0 ){
						v_type=4;
					}else if ( strcmp(v_str_type, "dvd") == 0 ){
						v_type=4;
					}else if ( strcmp(v_str_type, "cdrom") == 0 ){
						v_type=4;
					}
					//sd_mmc type=1
					//portable_audio_player type=2					
					g_print("v_type=%s   type=%i   v_bus=%s   v_fs=%s   v_size=%iMb   usb-storage=%i\n", v_str_type, v_type, v_str_bus, v_str_fs, v_size, v_usbstorage);
					
				  }
			  }
			}//if (stat(v_dev, &statbuf) 
		  }//if (udev == NULL){
	}
	
	
	//try add
	if (v_dev!=NULL){

		char myimg[1024]; 
		if (v_mount==TRUE) {
			if ( v_type==0 ) snprintf(myimg, 1024, "%sblockdevice.png", ICON_PATH);
			if ( v_type==1 ) snprintf(myimg, 1024, "%ssd_mmc_mount.png", ICON_PATH);
			if ( v_type==2 ) snprintf(myimg, 1024, "%sipod_mount.png", ICON_PATH);
			if ( v_type==3 ) snprintf(myimg, 1024, "%susbdrive_mount.png", ICON_PATH);
			if ( v_type==4 ) snprintf(myimg, 1024, "%scdrom_mount.png", ICON_PATH);
			if ( v_type==5 ) snprintf(myimg, 1024, "%susbpendrive_mount.png", ICON_PATH);
			if ( v_type==6 ) snprintf(myimg, 1024, "%susbdrive_mount.png", ICON_PATH);
		}else{
			if ( v_type==0 ) snprintf(myimg, 1024, "%sblockdevice.png", ICON_PATH);
			if ( v_type==1 ) snprintf(myimg, 1024, "%ssd_mmc_unmount.png", ICON_PATH);
			if ( v_type==2 ) snprintf(myimg, 1024, "%sipod_unmount.png", ICON_PATH);
			if ( v_type==3 ) snprintf(myimg, 1024, "%susbdrive_unmount.png", ICON_PATH);
			if ( v_type==4 ) snprintf(myimg, 1024, "%scdrom_unmount.png", ICON_PATH);
			if ( v_type==5 ) snprintf(myimg, 1024, "%susbpendrive_unmount.png", ICON_PATH);
			if ( v_type==6 ) snprintf(myimg, 1024, "%susbdrive_unmount.png", ICON_PATH);
		} 

		char newlabel[1024];
		
		if (v_label!=NULL){
			snprintf(newlabel, 20, "\"%s", v_label);
			if (v_mount==TRUE && f_path!=NULL ){
				snprintf(temp, 35, "%s\" %s", newlabel, f_path);	
			}else{
				snprintf(temp, 35, "%s\" %s", newlabel, v_dev);	
			}
		}else if (v_name!=NULL){
			snprintf(newlabel, 20, "\"%s", v_name);
			if (v_mount==TRUE && f_path!=NULL){
				snprintf(temp, 35, "%s\" %s", newlabel, f_path);	
			}else{
				snprintf(temp, 35, "%s\" %s", newlabel, v_dev);	
			}			
		}else{
			if (v_mount==TRUE){
				snprintf(temp, 35, "%s", f_path);	
			}else{
				snprintf(temp, 35, "%s", v_dev);	
			}
		}

		float my_size=((float)v_size)/1024;		
		
		if (my_size>0){
					snprintf(newlabel, 1024, "%s (%.1f Gb)", temp, my_size);
		}else{
					snprintf(newlabel, 1024, "%s", temp);
		}			

		char txt[80];
		
		m->submenu = gtk_menu_new();
		//m->submenuitem =  gtk_menu_item_new_with_label(txt);
		m->submenuitem =  gtk_image_menu_item_new_with_label(newlabel);
		m->img = gtk_image_new_from_file(myimg);
		gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(m->submenuitem), m->img);
		gtk_widget_show(m->submenuitem);
		gtk_menu_item_set_submenu(GTK_MENU_ITEM(m->submenuitem), m->submenu);
		gtk_menu_shell_append(GTK_MENU_SHELL(menu), m->submenuitem);


		//MOUNT

		snprintf(txt, 80, "%s", _("Mount"));

		//m->item_mount = gtk_menu_item_new_with_label(txt);
		m->item_mount = gtk_image_menu_item_new_with_label(txt);
		m->item_m_i = gtk_image_new_from_file(ICON_PATH "mount.png");
		gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(m->item_mount), m->item_m_i);
	    gtk_widget_show(m->item_mount);
	    gtk_menu_shell_append(GTK_MENU_SHELL(m->submenu), m->item_mount);
		g_signal_connect(G_OBJECT(m->item_mount), "activate", G_CALLBACK(mount_device), m);


		//VIEW

	    snprintf(txt, 80, "%s %s", _("Access content on"), v_dev);

	    //m->item_content = gtk_menu_item_new_with_label(txt);
	    m->item_content =gtk_image_menu_item_new_with_label(txt);
		m->item_c_i = gtk_image_new_from_file(ICON_PATH "look.png");
		gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(m->item_content), m->item_c_i);
	    gtk_widget_show(m->item_content);
	    gtk_menu_shell_append(GTK_MENU_SHELL(m->submenu), m->item_content);
	    g_signal_connect(G_OBJECT(m->item_content), "activate", G_CALLBACK(access_device), m);


		//UMOUNT
	
		snprintf(txt, 80, "%s %s", _("Safely remove"), v_dev);

		//m->item = gtk_menu_item_new_with_label(txt);
		m->item = gtk_image_menu_item_new_with_label(txt);
		m->item_i = gtk_image_new_from_file(ICON_PATH "unmount.png");
		gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(m->item), m->item_i);
		gtk_widget_show(m->item);
		gtk_menu_shell_append(GTK_MENU_SHELL(m->submenu), m->item);
		g_signal_connect(G_OBJECT(m->item), "activate", G_CALLBACK(eject_device), m); 
		
		
		//add param
		if (v_label==NULL) v_label=strdup("");
		if ( (m->label = strdup(v_label))==NULL ) m->label = strdup("");
		
		if (v_str_type==NULL) v_str_type=strdup("");
		if ( (m->ctype = strdup(v_str_type))==NULL ) m->ctype = strdup("");
				
		if (v_str_fs==NULL) v_str_fs=strdup("");
		if ( (m->fstype = strdup(v_str_fs))==NULL ) m->fstype = strdup("");
		//if ( (m->opt = strdup(opt))==NULL ) m->opt = strdup("");
				
		if (v_dev==NULL) v_dev=strdup("");		
		if ( (m->blockdev = strdup(v_dev))==NULL ) m->blockdev = strdup("");
				
		if (f_path==NULL) f_path=strdup("");				
		if ( (m->mountpoint = strdup(f_path))==NULL ) m->mountpoint = strdup("");
		
		if (v_name==NULL) v_name=strdup("");				
		if ( (m->name = strdup(v_name))==NULL ) m->name = strdup("");

		//if (v_kinduuid==NULL) v_kinduuid=strdup("");		
		//if ( (m->voluuid = strdup(v_kinduuid))==NULL ) m->voluuid = strdup("");		

		
		char * u;
		snprintf(temp, 1024, "%p", vol);
		u=strdup(temp);
		m->udi = strdup(u);
		//m->infstab=infstab;
		m->size=v_size;
		m->type=v_type;
		m->eject=0;
		if (v_can_eject==TRUE) m->eject=1;


		if (v_mount==TRUE) {
			m->mount=1;
			gtk_widget_show(m->item); //можно
			gtk_widget_show(m->item_content); //можно
			gtk_widget_hide(m->item_mount); //запрет
		} else {
			m->mount=0;
			gtk_widget_hide(m->item); //можно
			gtk_widget_hide(m->item_content); //можно
			gtk_widget_show(m->item_mount); //запрет
		}

		m->vol=vol;
		
		g_hash_table_insert(dev, u, m); 		
		
	}

    g_free (v_name);
    g_free (v_uuid);
    g_free (v_haludi);
    g_free (v_label);
    g_free (v_dev);
    g_free (v_nfs);
    g_free (v_kinduuid);
    //v_can_eject

	//v_mount	
    g_free (f_uri);
    g_free (f_path);    
    g_free (m_name);
    g_free (m_uuid);

	//v_drive	
    g_free (d_name);

	//v_devinfo
    g_free (v_str_type);
    g_free (v_str_fs);
    g_free (v_str_bus);
    g_free (v_str_size);   
    //int v_type=0;
    //int v_size=0;      
    //int v_usbstorage=0;    
    
    update_status();         

    return TRUE;
}
//++++++++++++++++ add_volume



//++++++++++++++++ changed_volume
static gboolean changed_volume(GVolume* vol)
{

	char * u;
	char temp[1024];
	snprintf(temp, 1024, "%p", vol);
	u=strdup(temp);
	g_print("changed_volume: %s\n", u);

	
	GFile  *file;
	GMount* mount;
	
	gboolean v_mount=FALSE;
	char * f_path=NULL;    
	mount = g_volume_get_mount(vol);
	
	if(mount) {//if  mount is NULL   - dev not mount
		v_mount=TRUE;
		file = g_mount_get_root(mount);
		f_path = g_file_get_path (file);
	        g_print("path=%s\n", f_path);		
		    g_object_unref (file);
	}	
	
	
	    gpointer data;
	    if ( ( data=g_hash_table_lookup(dev, u) ) !=NULL){
	        //есть
	        struct mdev *m=data;

		char *v_dev = m->blockdev;
		int v_type = m->type;
		char *v_label = m->label;
		int v_size = m->size;
		char *v_name = m->name;
		

		char newlabel[1024];
		
		if (strcmp(v_label, "") != 0){
			snprintf(newlabel, 20, "\"%s", v_label);
			if (v_mount==TRUE && f_path!=NULL ){
				snprintf(temp, 35, "%s\" %s", newlabel, f_path);	
			}else{
				snprintf(temp, 35, "%s\" %s", newlabel, v_dev);	
			}
		}else if (strcmp(v_name, "") != 0){
			snprintf(newlabel, 20, "\"%s", v_name);
			if (v_mount==TRUE && f_path!=NULL){
				snprintf(temp, 35, "%s\" %s", newlabel, f_path);	
			}else{
				snprintf(temp, 35, "%s\" %s", newlabel, v_dev);	
			}			
		}else{
			if (v_mount==TRUE){
				snprintf(temp, 35, "%s", f_path);	
			}else{
				snprintf(temp, 35, "%s", v_dev);	
			}
		}

		float my_size=((float)v_size)/1024;		
		
		if (my_size>0){
					snprintf(newlabel, 1024, "%s (%.1f Gb)", temp, my_size);
		}else{
					snprintf(newlabel, 1024, "%s", temp);
		}

		char myimg[1024]; 
		if (v_mount==TRUE) {
			if ( v_type==0 ) snprintf(myimg, 1024, "%sblockdevice.png", ICON_PATH);
			if ( v_type==1 ) snprintf(myimg, 1024, "%ssd_mmc_mount.png", ICON_PATH);
			if ( v_type==2 ) snprintf(myimg, 1024, "%sipod_mount.png", ICON_PATH);
			if ( v_type==3 ) snprintf(myimg, 1024, "%susbdrive_mount.png", ICON_PATH);
			if ( v_type==4 ) snprintf(myimg, 1024, "%scdrom_mount.png", ICON_PATH);
			if ( v_type==5 ) snprintf(myimg, 1024, "%susbpendrive_mount.png", ICON_PATH);
			if ( v_type==6 ) snprintf(myimg, 1024, "%susbdrive_mount.png", ICON_PATH);
		}else{
			if ( v_type==0 ) snprintf(myimg, 1024, "%sblockdevice.png", ICON_PATH);
			if ( v_type==1 ) snprintf(myimg, 1024, "%ssd_mmc_unmount.png", ICON_PATH);
			if ( v_type==2 ) snprintf(myimg, 1024, "%sipod_unmount.png", ICON_PATH);
			if ( v_type==3 ) snprintf(myimg, 1024, "%susbdrive_unmount.png", ICON_PATH);
			if ( v_type==4 ) snprintf(myimg, 1024, "%scdrom_unmount.png", ICON_PATH);
			if ( v_type==5 ) snprintf(myimg, 1024, "%susbpendrive_unmount.png", ICON_PATH);
			if ( v_type==6 ) snprintf(myimg, 1024, "%susbdrive_unmount.png", ICON_PATH);
		} 

		//change icon
		gtk_image_set_from_file((GtkImage *) m->img, myimg);

	        char txt[80];
		
		gtk_menu_item_set_label((GtkMenuItem *) m->submenuitem, newlabel);

		snprintf(txt, 80, "%s %s", _("Safely remove"), v_dev);
		gtk_menu_item_set_label((GtkMenuItem *) m->item, txt);

    		snprintf(txt, 80, "%s %s", _("Access content on"), v_dev);
		gtk_menu_item_set_label((GtkMenuItem *) m->item_content, txt);

		snprintf(txt, 80, "%s", _("Mount"));
		gtk_menu_item_set_label((GtkMenuItem *) m->item_mount, txt);


	        if (v_mount==TRUE) {
			//count++;
			m->mount=1;
			gtk_widget_show(m->item); //можно
			gtk_widget_show(m->item_content); //можно
			gtk_widget_hide(m->item_mount); //запрет
			if (f_path==NULL) f_path=strdup("");				
			if ( (m->mountpoint = strdup(f_path))==NULL ) m->mountpoint = strdup("");
    		} else {
			//count--;
			m->mount=0;
			gtk_widget_hide(m->item); //можно
			gtk_widget_hide(m->item_content); //можно
			gtk_widget_show(m->item_mount); //запрет
    		}
	    }//if ( ( data=g_hash_table_lookup(dev, u) ) !=NULL){    	
	
	
	update_status();
	g_print("changed_volume - end\n");
    return TRUE;
}
//++++++++++++++++ changed_volume



//++++++++++++++++ remove_volume
static gboolean remove_volume(GVolume* vol)
{
	char * u;
	char temp[1024];
	snprintf(temp, 1024, "%p", vol);
	u=strdup(temp);
	g_hash_table_remove(dev, u);

    return TRUE;
}
//++++++++++++++++ remove_volume


//++++++++++++++++ on_vol_added       (init_udev->on_vol_added)
static void on_vol_added(GVolumeMonitor* vm, GVolume* vol, gpointer user_data)
{
    add_volume(vol);
    g_print("on_vol_added: %p is added\n", vol);
}
//++++++++++++++++ on_vol_added


//++++++++++++++++ on_vol_removed (init_udev->on_vol_removed)
static void on_vol_removed(GVolumeMonitor* vm, GVolume* vol, gpointer user_data)
{
    remove_volume(vol);
    g_print("on_vol_removed: %p is removed\n", vol);
}
//++++++++++++++++ on_vol_removed


//++++++++++++++++ on_vol_changed (init_udev->on_vol_changed)
static void on_vol_changed(GVolumeMonitor* vm, GVolume* vol, gpointer user_data)
{
	
    GMount* mount = g_volume_get_mount(vol);     //Gets the mount for the volume.
    g_print("on_vol_changed: %p is changed, mount = %p\n", vol, mount);
    if(mount) {//if  mount is NULL   - dev not mount
        g_object_unref(mount);   //Decreases the reference count of object. When its reference count drops to 0, the object is finalized
    }
    changed_volume(vol);
    g_print("on_vol_changed end\n");
    
}
//++++++++++++++++ on_vol_changed


//++++++++++++++++ on_mount_added (init_udev->on_mount_added)
static void on_mount_added(GVolumeMonitor* vm, GMount* mount, gpointer user_data)
{
    //GError *error=NULL;
    GFile  *root;
    char   *rooturi;

    g_print("on_mount_added: mount = %p\n", mount);
    if(mount) {//if  mount is NULL   - dev not mount
	root = g_mount_get_root (mount);
	rooturi = g_file_get_uri (root);
        g_print("on_mount_added: mount = true rooturi=%s\n", rooturi);
	g_object_unref (root);
	g_free (rooturi);
    }else{
        g_print("on_mount_added: mount = false");
    }
    GVolume* vvol= g_mount_get_volume(mount);
    changed_volume(vvol);
    g_object_unref(vvol);

}
//++++++++++++++++ on_mount_added


//++++++++++++++++ on_mount_preunmount (init_udev->on_mount_removed)
static void on_mount_preunmount(GVolumeMonitor* vm, GMount* mount, gpointer user_data)
{
    //GError *error=NULL;
    GFile  *root;
    char   *rooturi;

    g_print("on_mount_removed: mount = %p\n", mount);
    if(mount) {//if  mount is NULL   - dev not mount
	root = g_mount_get_root (mount);
	rooturi = g_file_get_uri (root);
        g_print("on_mount_removed: mount = true rooturi=%s\n", rooturi);
	g_object_unref (root);
	g_free (rooturi);
    }else{
        g_print("on_mount_removed: mount = false");
    }
    GVolume* vvol= g_mount_get_volume(mount);
    changed_volume(vvol);
    g_object_unref(vvol);

}
//++++++++++++++++ on_mount_preunmount


//+++++++++++++ init_udev (main->init_udev) run only once
static int init_udev(void)
{

        vol_mon = g_volume_monitor_get();
        if(G_UNLIKELY(!vol_mon)){
		fprintf(stderr, "can't initialize\n");
                return -1;
        }

        //all ok... continue
        g_signal_connect(vol_mon, "volume-added", G_CALLBACK(on_vol_added), NULL);
        g_signal_connect(vol_mon, "volume-removed", G_CALLBACK(on_vol_removed), NULL);
        g_signal_connect(vol_mon, "volume-changed", G_CALLBACK(on_vol_changed), NULL);
        g_signal_connect(vol_mon, "mount-added", G_CALLBACK(on_mount_added), NULL);
        g_signal_connect(vol_mon, "mount-pre-unmount", G_CALLBACK(on_mount_preunmount), NULL);

        //all ok... continue
        GList* myvol, *mylist;
        myvol = g_volume_monitor_get_volumes(vol_mon); //Gets a list of the volumes on the system
        for(mylist=myvol;mylist;mylist=mylist->next)
        {
            GVolume* vvol = G_VOLUME(mylist->data);
            add_volume(vvol);
            g_object_unref(vvol);
        }
        g_list_free(myvol);

	if (usefloppy>-1) {
		g_print("+++++++++++++++++++++++++++++++++++++++++++++++++\n"); 
	    //we have floppy drive %)
	    floppymenu();
		g_print("floppy=/dev/fd%i\n", usefloppy);
	}


	countotal=0;
	update_status();

	return 0;
}
//+++++++++++++ init_udev


//+++++++++++++ readfstab (main->readfstab) (run only once)
static void readfstab(void)
{
	//first of all read /etc/fstab file in GList * fstabdrive and GList * allfstabdrive and GList * allfstabmountpoint
	
	//g_print("%i\n", g_list_length(fstabdrive));
	char string[300], strmp[300], strmp2[300], strdev[300], strdev2[300];
	int myi=0, myz=0, myzmp=0, find=0, fd=0, cd=0, byid=0;
	FILE *myfile;
	strcpy(floppymp,"");

	if ( ( myfile=fopen("/etc/fstab", "r") )!=(FILE *)0  ){
	    while ( ( fgets(string, 299, myfile) )!=(char *)0  ){
		//parsing string

		find=0;
		myz=0;
		myzmp=0;

		strcpy(strmp,"");
		strcpy(strdev,"");
		fd=0;
		cd=0;
		byid=0; //string like /dev/disk/by-... - try by mount point
		for (myi=0; myi<298; myi++){
		  if ( find ==0 ){
		    if ( (char) string[myi]==35 ) { // # this is comment in fstab
			    find=999; 
		    }

		    if (myi+20<298){

			if ( usefloppy==-999 && (char) string[myi]==47 && (char) string[myi+1]==100 && (char) string[myi+2]==101 && (char) string[myi+3]==118 && (char) string[myi+4]==47  && (char) string[myi+5]==102  && (char) string[myi+6]==100  ){ // /dev/fdX ? - see floppy drive
			    if ( (char) string[myi+7]==48 ) { usefloppy=0; fd=1;};
			    if ( (char) string[myi+7]==49 ) { usefloppy=1; fd=1;};
			    if ( (char) string[myi+7]==50 ) { usefloppy=2; fd=1;};
			    // fd0 fd1 fd2 or fd3
			    find=1;
			}else if ( (char) string[myi]==47 && (char) string[myi+1]==100 && (char) string[myi+2]==101 && (char) string[myi+3]==118 && (char) string[myi+4]==47  ){ // /dev/
			     if ( (char) string[myi+5]==104 && (char) string[myi+6]==100 ){ // hd
				    if ( (char) string[myi+8]==32 || (char) string[myi+8]==9 ) cd=1;  // this is not  hd.X this is hd. - maybe it is CD-ROM ?
				    find=1;
				    snprintf(strdev, 300, "%s", "/dev/hd");
				    myi=myi+7;
				    myz=7;
			     } else if ( (char) string[myi+5]==115 && (char) string[myi+6]==100 ){  // sd
				    if ( (char) string[myi+8]==32 || (char) string[myi+8]==9 ) cd=1;  // this is not  sd.X this is sd. - maybe it is CD-ROM ?
				    find=1;
				    snprintf(strdev, 300, "%s", "/dev/sd");
				    myi=myi+7;
				    myz=7;
			     } else if ( (char) string[myi+5]==115 && (char) string[myi+6]==99 && (char) string[myi+7]==100 ){  // scd
				    cd=1;
				    find=1;
				    snprintf(strdev, 300, "%s", "/dev/scd");
				    myi=myi+8;
				    myz=8;
			     } else if ( (char) string[myi+5]==115 && (char) string[myi+6]==114 ){  // sr
				    cd=1;
				    find=1;
				    snprintf(strdev, 300, "%s", "/dev/sr");
				    myi=myi+7;
				    myz=7;
			     } else if ((char) string[myi+5]==100 && (char) string[myi+6]==105 && (char) string[myi+7]==115 && (char) string[myi+8]==107 && (char) string[myi+9]==47 && (char) string[myi+10]==98 && (char) string[myi+11]==121 && (char) string[myi+12]==45 ) { //if string as /dev/disk/by-
			    	    find=1;
			    	    myi=myi+13;
			    	    byid=1;
			     }
			}else if ( (char) string[myi]==85 && (char) string[myi+1]==85 && (char) string[myi+2]==73 && (char) string[myi+3]==68 ){ // UUID

				    find=1;
				    myi=myi+5; // + "=" letter
				    myz=0;
			} else if ( (char) string[myi]==117 && (char) string[myi+1]==117 && (char) string[myi+2]==105 && (char) string[myi+3]==100 ){ // uuid

				    find=1; 
				    myi=myi+5; // + "=" letter
				    myz=0;
			}
		    }
		  }//find==0


		  if (  find==1 && ( (char) string[myi]==32 ||  (char) string[myi]==9 )  ){ find=2;  }; //end of uuid or device

		  if ( find==1 ) {
			    snprintf(strdev2, 300, "%s", strdev);
			    snprintf(strdev, 300, "%s%c", strdev2, string[myi]);
			    myz++;
		  }
		  
		  if ( find==2 && myi>5 && (  ( (char) string[myi-1]==32 && (char) string[myi]==47 ) || ( (char) string[myi-1]==9 && (char) string[myi]==47 )  ) ){ // {spase}/  or {tab}/
			    find=3; //it is mount point
		  }
		  
		  if ( find==3 && ( (char) string[myi]==32 || (char) string[myi]==9 ) ){
			    find=4; //it is end of mount point
		  }
		  
		  if ( find==3 ){ //see mount point for floppy or disk with disk/by-*
			    snprintf(strmp2, 300, "%s", strmp);
			    snprintf(strmp, 300, "%s%c", strmp2, string[myi]);
			    myzmp++;
			    myz++;
			    //see word cdrom
			    if (myz+5<298) {
				if ( (char) string[myi]==99 &&  (char) string[myi+1]==100  &&  (char) string[myi+2]==114  &&  (char) string[myi+3]==111  &&  (char) string[myi+4]==109  ) {cd=1;}; //this is cdrom
			    }
		  } //find==2

		  if ( find==4 &&  (char) string[myi]!=32 && (char) string[myi]!=9 ){
			    find=5; //it is options begin
		  }

		  if ( find==5 && ( (char) string[myi]==32 || (char) string[myi]==9 ) ){
			    find=6; //it is options end
			    break; //end parse string
		  }

		  if ( find==5 && myi+3<298  ){
			//in options iso9 ? it is cd-rom
			if (  (char) string[myi]==105  &&  (char) string[myi+1]==115  &&  (char) string[myi+2]==111  &&  (char) string[myi+3]==57 )  {cd=1;}
		  }

		  
		  if (  (char) string[myi]=='\0' ) { break;}; //cant find any letter - end parse string
		  if ( find==999){ break; }; //end parse string
		}//for

		if ( myz>0 && find==6 && fd==0 && cd==0 && byid==0){ //this is invisible device by uuid or /dev/xxxx
g_print("dev_or_uuid=%s\n", strdev);
		    fstabdrive=g_list_append(fstabdrive, strndup(strdev, myz));
		}
		if ( myz>0 && myzmp>0 && find==6 && fd==0 && cd==0 && byid==1){  //this is invisible device by mount point
g_print("by-id=%s\n", strmp);
		    fstabdrive=g_list_append(fstabdrive, strndup(strmp, myzmp));
		}
		if ( myz>0 && myzmp>0 && find==6 ){  //this is list of device for mount thru "mount" command
g_print("allfstabdrive=%s| mountpoint=|%s|\n", strdev, strmp);
		    allfstabdrive=g_list_append(allfstabdrive, strndup(strdev, myz));
		    allfstabmountpoint=g_list_append(allfstabmountpoint, strndup(strmp, myzmp));
		}
		if (fd==1){
		  if ( myzmp>0 && find==6){
g_print("floppy_mp=%s\n", strmp);
		    snprintf(floppymp, 256, "%s", strmp);
		  }else{
		    usefloppy=-999;
		  }
		}
	    }//while
	    fclose(myfile);
	}
}
//+++++++++++++ readfstab


//+++++++++++ value_destroy (main->value_destroy)
void value_destroy(gpointer data)
{
	struct mdev *m = data;
	g_print("value_destroy-begin\n");
	gtk_widget_destroy(m->img);
	gtk_widget_destroy(m->item_i);
	gtk_widget_destroy(m->item_m_i);
	gtk_widget_destroy(m->item_c_i);
	gtk_widget_destroy(m->item);
	gtk_widget_destroy(m->item_mount);
	gtk_widget_destroy(m->item_content);
	gtk_widget_destroy(m->submenu);
	gtk_widget_destroy(m->submenuitem);
	g_object_unref(m->vol);
	g_print("value_destroy-end\n");
	free(m);
}
//+++++++++++ value_destroy

//+++++++++++ key_destroy   (main->key_destroy)
void key_destroy(gpointer data)
{
	free(data);
}
//+++++++++++ key_destroy


//MAIN ++++++++++++++++
int main(int argc, char **argv)
{
	bindtextdomain("tray_eject_plus", LOCALE_DIR);
        textdomain("tray_eject_plus");

	gtk_init(&argc, &argv);

	struct stat st;

	// read args (if programms run with args) and try read fileman
	int zz;
	char oldfileman[256];
	if (argc > 1) {
	  for (zz = 1; zz < argc; zz++) {
	    sprintf(oldfileman,"%s", fileman);
	    sprintf(fileman,"%s%s ", oldfileman, argv[zz]);
	  }
	} else {

	  sprintf(fileman,"nautilus --no-desktop "); //by default  fileman = "nautilus --no-desktop"

	  if ( stat("/usr/bin/thunar", &st)==0 ) {
	    sprintf(fileman,"thunar ");
	  } else if ( stat("/usr/bin/pcmanfm2", &st)==0 ) {
	    sprintf(fileman,"pcmanfm2 ");
	  } else if ( stat("/usr/bin/pcmanfm", &st)==0 ) {
	    sprintf(fileman,"pcmanfm ");
	  }else if ( stat("/usr/local/bin/thunar", &st)==0 ) {
	    sprintf(fileman,"thunar ");
	  } else if ( stat("/usr/local/bin/pcmanfm2", &st)==0 ) {
	    sprintf(fileman,"pcmanfm2 ");
	  } else if ( stat("/usr/local/bin/pcmanfm", &st)==0 ) {
	    sprintf(fileman,"pcmanfm ");
	  }

	}

//g_print("fm|%s|\n", fileman);

	count = 0; //mount dev count

	//create hash table
	//key_destroy - run if delete key
	//value_destroy - run if delete value
	dev = g_hash_table_new_full(g_str_hash, g_str_equal, key_destroy,
							value_destroy);

	icon = (GtkStatusIcon *) gtk_status_icon_new_from_file(ICON_PATH "dev1.png");

	update_status(); //ф-я

	countotal=-999; //all dev count (-999 for speed)


	menu = gtk_menu_new(); //menu


	usefloppy=-999;
	readfstab(); //read fstab
g_print("g_list %i\n", g_list_length(fstabdrive));

	g_signal_connect(G_OBJECT(icon), "button-press-event", G_CALLBACK(popup), NULL); //if mouse button press - run popup

	//run init_udev or die :)
	if (init_udev() < 0)
		return 1;


	//dialogs and message
	dialog = gtk_dialog_new_with_buttons("Error", NULL,
			GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
			GTK_STOCK_OK, GTK_RESPONSE_OK,
			NULL);
	gtk_window_set_icon_from_file(GTK_WINDOW(dialog), ICON_PATH "error.png", NULL);

	msg = gtk_label_new(_("Unable to unmount this device. Some\napplication is likely to be using it.\nPlease close the offending application\nand try again."));
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), msg, TRUE, TRUE, 10);
        gtk_widget_show(msg);

	dialog2 = gtk_dialog_new_with_buttons("Error", NULL,
			GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
			GTK_STOCK_OK, GTK_RESPONSE_OK,
			NULL);
	gtk_window_set_icon_from_file(GTK_WINDOW(dialog2), ICON_PATH "error.png", NULL);

	msg2 = gtk_label_new(_("Unable to mount this device"));
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog2)->vbox), msg2, TRUE, TRUE, 10);
        gtk_widget_show(msg2);

	//go-go
	gtk_main();

	return 0;
}
